#    TESTNET is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    TESTNET is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with TESTNET.  If not, see <http://www.gnu.org/licenses/>.

#-----------------------------------------------------------------------------------------#

# Author: Federico Salotti
# Organization/Company: Mr_Robot_Computers_Repair 
# Country: Italy Barga(LU)
# release: 1.0.3 (18 December 2019 19:11)


use warnings;
use feature "say";
use Term::ANSIColor;
use POSIX qw (strftime);
use LWP::UserAgent;
use Time::HiRes qw(time);
use Getopt::Long;
use HTTP::Request::Common;
$HTTP::Request::Common::DYNAMIC_FILE_UPLOAD=1;
use threads;
use threads::shared;
use Net::Ping;

$|=1;
$data_ascii_flux="===============";
@ascii_clock=qw(- \ | /);

$URL_DW_SERVER="http://speedtest.tele2.net/20MB.zip";
$URL_UP_SERVER="http://speedtest.tele2.net/upload.php";


sub end_section
{
	print color("bold cyan");
	print "\t";
	print "~ ~" x 40;
	print "\n\n";
	print color("reset");
}

sub asSeconds
{
	my $minutes=substr($_[0],0,2);
	my $seconds=substr($_[0],3,5);

#	say " minuti : $minutes";
#	say "secondi : $seconds";

	$seconds=int($minutes)*60+$seconds;
#	say "tempo in secondi : $seconds";

	return $seconds;
}


GetOptions
(
	"mode=s" => \$mode,
	"target=s" => \$target,
	"timeout=i" => \$timeout,
	"packetsize=i" =>\$packetsize,
	"datasize=i" => \$datasize,
	"datatype=s" => \$datatype,
	"save" => \$save,
	"path=s" => \$savepath,
	"help" => \$help
);

$mode="complete" unless $mode;
$datasize=20 unless $datasize;
$datatype="MB" unless $datatype;

$datatype = uc $datatype;


if(uc $datatype ne "MB" && uc $datatype ne "GB") {$datatype="MB";}


if(uc $datatype eq "MB")
{
	if($datasize <= 1) {say color("bold red"); say "[!] Not valid data size  (datasize <= 1)"; say color("reset");exit;}
	elsif($datasize == 10) {$URL_DW_SERVER="http://speedtest.tele2.net/10MB.zip";$testnet_data="data_packets/10MB.zip";}
	elsif($datasize == 20) {$URL_DW_SERVER="http://speedtest.tele2.net/20MB.zip";$testnet_data="data_packets/20MB.zip";}
	elsif($datasize == 100) {$URL_DW_SERVER="http://speedtest.tele2.net/100MB.zip";$testnet_data="data_packets/20MB.zip";}
	else
	{
		print color("bold red");
		print "[!] Invalid packet datasize : choose between\n";
		print color("reset");
		print color("red");

		print "[-] 10 MB\n";
		print color("green");
		print "\e[5m[-] 20 MB <- default\e[25m\n";
		print color("reset");
		print color("red");
		print "[-] 50 MB\n";
		print "[-] 100 MB\n";
		print color("reset");
		exit;
	}
}
elsif( uc $datatype eq "GB")
{
	if($datasize == 20) {$URL_DW_SERVER="http://speedtest.tele2.net/1GB.zip";$testnet_data="data_packets/20MB.zip"; $datasize=1} # not set
	elsif($datasize == 1) {$URL_DW_SERVER="http://speedtest.tele2.net/1GB.zip";$testnet_data="data_packets/20MB.zip";}
	elsif($datasize == 10) {$URL_DW_SERVER="http://speedtest.tele2.net/10GB.zip";$testnet_data="data_packets/20MB.zip";}
	elsif($datasize == 50) {$URL_DW_SERVER="http://speedtest.tele2.net/50GB.zip";$testnet_data="data_packets/20MB.zip";}
	elsif($datasize == 100) {$URL_DW_SERVER="http://speedtest.tele2.net/100GB.zip";$testnet_data="data_packets/20MB.zip";}
	elsif($datasize == 1000) {$URL_DW_SERVER="http://speedtest.tele2.net/1000GB.zip";$testnet_data="data_packets/20MB.zip";}
	else
	{
		print color("bold red");
		print "[!] Invalid packet datasize : choose between\n";
		print color("reset");
		print color("green");

		print "\e[5m[-] 1 GB <- default\e[25m\n";
		print color("red");
		print "[-] 10 GB\n";
		print "[-] 50 GB\n";
		print "[-] 100 GB\n";
		print "[-] 1000 GB\n";
		print color("reset");
		exit;
	}
}

$packetsize=56 unless $packetsize;
$timeout=2 unless $timeout;
$target="www.google.com" unless $target;
$default_savepath="./testnet $mode ".localtime(time);
$savepath=$default_savepath unless $savepath;
share($save);

if($save) 
{
	$current_data=localtime(time);
	print color ("green");
	print "[+] Generation report in $savepath ..."; 
	print color ("reset");
	if($savepath ne $default_savepath)
	{
		$savepath =~ /\/$/g;
		if(!$1){$savepath.="/";}
		$savepath =~ s/\/$/\/testnet $mode $current_data/g;
	}
	open $REPORT, ">>", $savepath;
	select $REPORT;
}

$user=LWP::UserAgent->new;
$user->timeout(5000);


sub download_test
{
	 my $start=time();
	 $tick=0;share($tick); 
	 $i=0; share($i);
	 $status=0; share($status);

	my sub _work1_down
	{
		while(!$status){sleep(1);++$i;++$tick;}
	}

	my sub _work2_down
	{
		my $start_message="\t\t\e[31m\e[1m[+] Running download test\e[21m\e[39m [-]";
		if($save){threads->exit;}


		while(!$status)
		{
			if($i > length $data_ascii_flux) {$i=0;}
		        substr($data_ascii_flux,length($data_ascii_flux)-$i-1,1) = "<";				
			if($i != 0) {substr($data_ascii_flux,length($data_ascii_flux)-$i,1) = "=";}

			if($tick < scalar @ascii_clock) {substr($start_message,length($start_message)-2,1) = $ascii_clock[$tick];}
			else {$tick=0;substr($start_message,length($start_message)-2,1) = $ascii_clock[$tick];}
	
			print "\r\c[[K";
			print $start_message;
			print color("bold magenta");print "\t Packet size : $datasize $datatype";print color("reset");
			print color("bold green");
			print"\t[ YOU ]";
			print color("reset");
			print "$data_ascii_flux";
			print color("bold red");
			print "[ SERVER ]";
			print color("reset");
			sleep(1);
		}
	}

	my $th1=threads->create(\&_work1_down);
	my $th2=threads->create(\&_work2_down);

	$response=$user->get($URL_DW_SERVER);
	if($response->is_success) {$status=1;}
	else
	{
		$status=1;
		$response_code=$response->status_line;
		if($response_code =~ /(500)/g) {say "\n[!] ERROR $1 : Unable to estabilish connection";}
	}

	$th1->join(); $th2->join();

	my $end=time();
	my $max=$end - $start;

	my $microsec=($max - int($max))*1e6;
	$microsec=substr($microsec,0,2);

	$max=strftime("%M:%S:",localtime($max)).$microsec;
	say "\n\n\t\t\t\t\t\t\e[5m End download test : $max sec\e[25m";

	$max =~ s/:/./g;

	if(uc $datatype eq "GB") {$datasize=$datasize*1024;}
	$max=asSeconds($max);
	$download_speed=$datasize/($max/8);
	print color("bold green");
	print "\n\t\t\t\t\t\t [ Download speed : ";
	printf ("%.2f",$download_speed);
	print "/Mbps ]\n";
	print color("reset");
}

sub upload_test
{
	if($datasize > 20) {$datasize = 20;} # max upload size server  20

	 $tick=0;share($tick);
	 $i=0; share($i);
	 $status=0; share($status);

	my sub _work1_up
	{
		while(!$status) {sleep(1);++$i;++$tick;}
	}

	my sub _work2_up
	{

		my $start_message="\t\t\e[1m\e[31m[+] Running upload test\e[21m\e[39m [-]";



		if($save){threads->exit;}
		while(!$status)
		{
			if($i == 15) {$i=0}

			if($i != 0) {substr($data_ascii_flux,$i,1) = ">";}	
			else {substr($data_ascii_flux,0,1) = ">";}	
			substr($data_ascii_flux,$i-1,1) = "=";

			if($tick < scalar @ascii_clock) {substr($start_message,length($start_message)-2,1) = $ascii_clock[$tick];}
			else {$tick=0;substr($start_message,length($start_message)-2,1) = $ascii_clock[$tick];}

			print "\r\c[[K";

			print $start_message;
			print color("bold magenta");
			print "   Packet size $datasize"."MB";
			print color("reset");

			print color("bold red");
			print "   [ YOU ]";
			print color("reset");
			print $data_ascii_flux;
			print color("bold green");
			print "[ SERVER ]";
			print color("reset");
			sleep(1);
		}
	}

	my $th1=threads->create(\&_work1_up);
	my $th2=threads->create(\&_work2_up);

	my $start=time(); my $response=$user->post (
		$URL_UP_SERVER,
		Content_Type => "form-data",
		Content => [file => [$testnet_data] ],
	);
	if($response->is_success) {$status=1;}
	else
	{
		$status=1;
		$response_code=$response->status_line;

		if($response_code =~ /(413)/g) {say "\n[!] ERROR $1 : Inavalid upload data size";}
		if($response_code =~ /(500)/g) {say "\n[!] ERROR $1 : Unable to estabilish connection";}
	}

	$th1->join();$th2->join();

	my $end=time();
	my $max=$end - $start;
	my $microsec=($max - int($max))*1e6;
	$microsec=substr($microsec,0,2);
	$max=strftime("%M:%S:",localtime($max)).$microsec;
	print "\n\n\t\t\t\t\t\t\e[5m End upload test: $max sec\e[25m";

	$max =~ s/:/./g;
	$max=asSeconds($max);

	my $upload_speed=$datasize/($max/8);
	print color("bold green");
	print "\n\n\t\t\t\t\t\t [ Upload speed : ";
	printf ("%.2f",$upload_speed);
	print "/Mbps ]\n";
	print color("reset");

	#end_section;


}

sub ping_test
{
	my $ping=Net::Ping->new("tcp",$timeout,$packetsize);

	my $status=0; share($status);
	$ip=""; share($ip); 
	(my $return,my $duration,$ip) = $ping->ping($target);
	$i=0; share($i);
	$avg_ping=0;

	my sub _work1
	{

		while(!$status)
		{
			$start_message="\t\t\t\e[1m\e[31m[+] Starting ping test\e[21m\e[39m | IP : $ip | hostname : \e[4m$target\e[24m  [-]";

			if($i < scalar @ascii_clock)
			{
				substr($start_message,length ($start_message)-2,1) =$ascii_clock[$i];
				$i++;
			}
			else {$i=0;}
	
			print "\r\c[[K";	
			print "$start_message";
			
			#print "[-] IP : $ip [-] hostname : \e[4m$target\e[24m";
			sleep(1);

		}

		$start_message="\t\t\t\e[1m\e[31m[+] Starting ping test\e[21m\e[39m | IP : $ip | hostname : \e[4m$target\e[24m  [-]";
		print "\r\c[[K$start_message";


	}
	if(!$target)
	{
		say color("bold red");
		say "[!] No target selected";
		say color("reset");
		exit;
	}
	my $th1=threads->create(\&_work1);

	$ping_data=qx/ping -c 5 -s $packetsize $target/;

	@samples=$ping_data=~ /time=.*/g;

	foreach $sample (@samples) 
	{	
		$sample =~ s/time=|ms//g;
		$avg_ping+=$sample;
	}
	$avg_ping=$avg_ping / scalar @samples;
	$status=1;


	$th1->join();

#	my $latenza=$packetsize/$download_speed+$duration;
	print("\n\n\t\t\t\t\t\t \e[1m\e[92m [ Ping : ");
	printf("%.2f",$avg_ping);
	print("ms ]\n\n\e[21m\e[39m");

}

sub jitter_test
{
	my @samples=qw();
	my @samples_diff=qw();
	$jitter=undef; share($jitter);
	my $max_samples_collection=5;
	
	my $i=0; share($i);

	my sub _work1
	{

		while(!$jitter)
		{
			$start_message="\t\t\t\e[1m\e[31m[+] Starting jitter test\e[21m\e[39m [-]";

			if($i < scalar @ascii_clock)
			{
				substr($start_message,length ($start_message)-2,1) =$ascii_clock[$i];
				$i++;
			}
			else {$i=0;}
	
			print "\r\c[[K";	
			print "$start_message";
			sleep(1);

		}
	}

	my $th1=threads->create(\&_work1);


	if(!$target)
	{
		say color("bold red");
		say "[!] No target selected";
		say color("reset");
		exit;
	}
		
	$data_ping=qx/ping -c 5 $target/;

	@samples= $data_ping =~ /time=.* /g;
	@packet_loss= $data_ping =~ /[0-9]{1,}% packet loss/g;

	foreach $info (@packet_loss) {$info =~ s/ packet loss//;}

	foreach $sample (@samples) {$sample =~ s/time=//;}

	print "\t\e[4mPacket loss : $packet_loss[0]\e[24m";

	for(my $i=0; $i < scalar(@samples)-1 ; ++$i){$samples_diff[$i]=abs($samples[$i] - $samples[$i+1]);}

	foreach $sample_diff (@samples_diff) {$jitter+=$sample_diff;}

	$jitter=$jitter/scalar(@samples_diff);
	$th1->join();

	print "\t \e[1m\e[92m[ jitter : ";
	printf("%.2f",abs($jitter));
	print "ms ]\e[21m\e[39m\n\n";

	#end_section;

}


say color("cyan");

say "
\t\t\t████████╗███████╗███████╗████████╗███╗   ██╗███████╗████████╗    
\t\t\t╚══██╔══╝██╔════╝██╔════╝╚══██╔══╝████╗  ██║██╔════╝╚══██╔══╝    
\t\t\t   ██║   █████╗  ███████╗   ██║   ██╔██╗ ██║█████╗     ██║       
\t\t\t   ██║   ██╔══╝  ╚════██║   ██║   ██║╚██╗██║██╔══╝     ██║       
\t\t\t   ██║   ███████╗███████║   ██║   ██║ ╚████║███████╗   ██║       
\t\t\t   ╚═╝   ╚══════╝╚══════╝   ╚═╝   ╚═╝  ╚═══╝╚══════╝   ╚═╝  v1.0.3";

say color("reset");
HELP:
{
	if($help)
	{
		say "--mode { TEST MODALITY } | < dwonload > | < upload > | < download-upload > | < ping-jitter > DEFAULT = complete";
		say "--datatype { TYPE OF DATA  } < MB > | < GB > DEFAULT = MB";
		say "--datasize  { SIZE OF DATA  } --datatype MB < 10 > < 20 > < 100 > | --datatype GB < 1 > < 10 > < 50 > < 100 > < 1000 > [ DEFAULT MB = 20 ] [ DEFAULT GB = 1 ]",
		say "--target { URL FOR PING AND JITTER TEST } < URL > DEFAULT = google.com";
		say "--timeout { PING TIMEOUT } < int > DEFAULT = 2";
		say "--packetsize { PING PACKET SIZE (byte) } < int > DEFAULT = 56";
		say "--save { SAVE TEST } DEFAULT = false";
		say "--path { SAVE PATH } < path >";
		exit;
	}
}



if(lc $mode eq "complete")
{
	ping_test;
	end_section;
	jitter_test;
	end_section;
	download_test;
	end_section;
	upload_test;
}
elsif(lc $mode eq "download-upload" || lc $mode eq "upload-download")
{
	download_test;
	end_section;
	upload_test;
}

elsif(lc $mode eq "download") {download_test;end_section;}
elsif(lc $mode eq "upload") {upload_test;end_section;}
elsif(lc $mode eq "ping") {ping_test;end_section}
elsif(lc $mode eq "jitter") {jitter_test;end_section;}


elsif(lc $mode eq "ping-jitter" || lc $mode eq "jitter-ping")
{
	ping_test;
	end_section;
	jitter_test;
}

else {$help=1; goto HELP;}

if($save) 
{
	close $REPORT;
	select STDOUT;

	print color("green");
	print "\n[!] Report generated successfully!\n";
	print color("reset");
}


